第四十八天 第十章 单调栈part01 739. 每日温度 496.下一个更大元素 I 503.下一个更大元素II

739. 每日温度

使用单调栈:注意栈中的递增递减顺序。

复制代码
class Solution {
public:
    vector<int> dailyTemperatures(vector<int>& temperatures) {
       vector<int> res(temperatures.size(),0);
       stack<int> sta;
       sta.push(0);
       for(int i=1;i<temperatures.size();i++){
          if(temperatures[i]>temperatures[sta.top()]){
            while(!sta.empty() && temperatures[i]>temperatures[sta.top()]){ //注意要判断栈是否为空
            res[sta.top()]=i-sta.top();
            sta.pop();
            }
            sta.push(i);
          }  
          else{
            sta.push(i);
          }
       }
       return res;
    } 
};
/*暴力,超时
class Solution {
public:
    vector<int> dailyTemperatures(vector<int>& temperatures) {
       vector<int> res(temperatures.size(),0);
       for(int i=0;i<temperatures.size()-1;i++){
            for(int j=i+1;j<temperatures.size();j++){
                if(temperatures[i]<temperatures[j]){
                    res[i]=j-i;
                    break;
                }
            }
       }
       return res;
    }
};
*/

496.下一个更大元素 I

主要是要在nums2中查询nums1中元素的同时,要将nums1元素的下标保存。所以使用了map。

复制代码
class Solution {
public:
    vector<int> nextGreaterElement(vector<int>& nums1, vector<int>& nums2) {
        stack<int> st;
        vector<int> result(nums1.size(), -1);
        if (nums1.size() == 0) return result;

        unordered_map<int, int> umap; 
        for (int i = 0; i < nums1.size(); i++) {
            umap[nums1[i]] = i;
        }
        st.push(0);
        for (int i = 1; i < nums2.size(); i++) {
            while (!st.empty() && nums2[i] > nums2[st.top()]) {
                if (umap.count(nums2[st.top()])) { 
                    int index = umap[nums2[st.top()]]; 
                    result[index] = nums2[i];
                }
                st.pop();
            }
            st.push(i);
        }
        return result;
    }
};

503.下一个更大元素II

这题要处理循环数组,也就是多次遍历数组。我么可以:

1.两个nums数组拼接在一起。

2.其实也可以不扩充nums,而是在遍历的过程中模拟走了两遍nums数组。

复制代码
class Solution {
public:
    vector<int> nextGreaterElements(vector<int>& nums) {
        vector<int> res(nums.size(),-1);
        stack<int> sta;
        for(int i=0;i < nums.size()*2;i++){
            while(!sta.empty()&&nums[i%nums.size()]>nums[sta.top()]){
                res[sta.top()]=nums[i%nums.size()];
                sta.pop();
            }
            sta.push(i % nums.size());
        }
        return res;
    }
};
相关推荐
罗西的思考3 小时前
【Agentic RL】Dressage Staleness 控制深度分析
人工智能·算法·机器学习
quaer3 小时前
弗洛伊德算法--判圈法寻找环的入口O(n) O(1)
数据结构·算法
文丑颜不良啊5 小时前
LeetCode51~75题目解析
leetcode
高晶5 小时前
无乘法器实现LC二阶滤波器:基于移位运算的快速算法与四种精度推导
算法·设计模式·程序员
ysbfsy5 小时前
大数计算思路
算法
高晶5 小时前
主从自动分配算法:平均值乘以设备数一半的选举基准值解析
算法·设计模式·程序员
学电子她就能回来吗5 小时前
LeetCode Hot 100|普通数组专题学习笔记(零基础版)
笔记·算法·leetcode
用户老李5 小时前
反向传播计算梯度举例
算法
niyongsheng5 小时前
多智能体连续时间内路径规划:AA-SIPP(m) 的 Rust 实现与算法
算法·rust·机器人
302wanger6 小时前
DeepSeek-V4.1-Flash-1017 免费用到1024,速来
算法